package bowling;

import java.util.ArrayList;
import java.util.List;

public class BowlingLane {
    public static final int LAST_FRAME = 10;

    protected Frame currentFrame;

    protected List<Frame> frames = new ArrayList<Frame>();

    public BowlingLane() {
        for (int i = 0; i < LAST_FRAME - 1; i++) {
            frames.add(new Frame(frames));
        }
        frames.add(new LastFrame(frames));
        currentFrame = frames.get(0);
    }

    public int currentFramePosition() {
        return currentFrame.index() + 1;
    }

    public void dropPins(int pinsDropped) {
        currentFrame.drop(pinsDropped);

        if (!currentFrame.isLastFrame() && currentFrame.isComplete())
            nextFrame();
    }

    private void nextFrame() {
        currentFrame = currentFrame.nextFrame();
    }

    public boolean gameOver() {
        return currentFrame.isLastFrame() && currentFrame.isComplete();
    }

    public String[] pinsDropped(int frameNumber) {
        return frames.get(frameNumber - 1).displayPinsDropped();

    }

    public String score(int frameNumber) {
        Frame frame = frames.get(frameNumber - 1);
        Throw score = frame.score();
        return score.toString();
    }
}
